﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace ADO
{
    public partial class ADOConnected : Form
    {
        string          connStr;
        SqlConnection   conn;
        bool            isNew = false;
        int             authorID;
        
        public ADOConnected()
        {
            InitializeComponent();
        }

        private void ADODisconnected_Load(object sender, EventArgs e)
        {
            connStr = Properties.Settings.Default.connectionStr;
            conn = new SqlConnection(connStr);
            refreshList();
            listBox1.SelectedIndex = 0;
        }

        private void btnNew_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
            isNew = true;
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listBox1.SelectedItem != null)
            {
                isNew = false;
                authorID = ((Author)listBox1.SelectedItem).ID;
                textBox1.Text = listBox1.SelectedItem.ToString();
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (isNew) 
            {
                conn.Open();

                SqlCommand cmdInsert = new SqlCommand("insert into Authors values(@name)",conn);
                cmdInsert.Parameters.AddWithValue("name", textBox1.Text);
                cmdInsert.ExecuteNonQuery();
                
                conn.Close();

                refreshList();
            }
        }

        private void refreshList() 
        {
            listBox1.Items.Clear();

            string selectQuery = "select * from Authors";
            SqlCommand cmdSelect = new SqlCommand(selectQuery, conn);
            
            conn.Open();
            
            SqlDataReader reader = cmdSelect.ExecuteReader();
            while (reader.Read())
            {
                int authorID = Convert.ToInt32(reader["AuthorID"]);
                string name = reader["Name"].ToString();

                listBox1.Items.Add(new Author(name, authorID));
            }

            conn.Close();
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            if (!isNew) 
            {
                string queryString = "update Authors set name=@name where AuthorID=@id";
                SqlCommand cmdUpdate = new SqlCommand(queryString, conn);
                cmdUpdate.Parameters.AddWithValue("id", authorID);
                cmdUpdate.Parameters.AddWithValue("name", textBox1.Text);
                
                conn.Open();
                cmdUpdate.ExecuteNonQuery();
                conn.Close();
                
                refreshList();
            }
        }

        private void buttonDelete_Click(object sender, EventArgs e)
        {
            if (!isNew)
            {
                string queryString = "delete from Authors where AuthorID=@id";
                SqlCommand cmdDelete = new SqlCommand(queryString, conn);
                cmdDelete.Parameters.AddWithValue("id", authorID);

                conn.Open();
                cmdDelete.ExecuteNonQuery();
                conn.Close();

                refreshList();
                textBox1.Text = "";
            }
        }
    }
}
