﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace ADO
{
    public partial class ADODisconnected : Form
    {
        SqlConnection       conn;
        SqlDataAdapter      da;
        SqlCommandBuilder   builder;
        DataSet             ds;
        int                 selectedRow;

        public ADODisconnected()
        {
            InitializeComponent();
        }

        private void ADODisconnected_Load(object sender, EventArgs e)
        {
            string connStr = Properties.Settings.Default.connectionStr;

            conn = new SqlConnection(connStr);
            da = new SqlDataAdapter("select * from Titles", conn);
            builder = new SqlCommandBuilder(da);

            ds = new DataSet();
            da.Fill(ds);

            dataGridView1.DataSource = ds.Tables[0];

            fillComboBoxWithAuthors();
        }

        private void fillComboBoxWithAuthors()
        {
            SqlDataAdapter daCombo = new SqlDataAdapter("select * from Authors", conn);
            DataTable dtAuthors = new DataTable();
            daCombo.Fill(dtAuthors);

            comboBox1.DataSource = dtAuthors;
            comboBox1.DisplayMember = "Name";
            comboBox1.ValueMember = "AuthorID";
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (dataGridView1.SelectedRows.Count > 0)
            {
                DataRow dr = ds.Tables[0].Rows[selectedRow];
                dr.Delete();

                da.UpdateCommand = builder.GetUpdateCommand();
                da.Update(ds);
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            DataRow dr = ds.Tables[0].NewRow();

            dr["ISBN"] = txtISBN.Text;
            dr["BookTitle"] = txtTitle.Text;
            dr["EditionNumber"] = Convert.ToInt32(txtEdition.Text);
            dr["Copyright"] = txtCopy.Text;
            dr["AuthorID"]  =   Convert.ToInt32(comboBox1.SelectedValue);

            ds.Tables[0].Rows.Add(dr);

            da.UpdateCommand = builder.GetUpdateCommand();
            da.Update(ds);
        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            selectedRow = e.RowIndex;

            txtISBN.Text = ds.Tables[0].Rows[selectedRow]["ISBN"].ToString();
            txtTitle.Text = ds.Tables[0].Rows[selectedRow]["BookTitle"].ToString();
            txtEdition.Text = ds.Tables[0].Rows[selectedRow]["EditionNumber"].ToString();
            txtCopy.Text = ds.Tables[0].Rows[selectedRow]["CopyRight"].ToString();
            comboBox1.SelectedIndex = Convert.ToInt32(ds.Tables[0].Rows[selectedRow]["AuthorID"])-1;
        }

        private void btnNew_Click(object sender, EventArgs e)
        {
            foreach (Control control in this.Controls)
            {
                if (control.GetType() == typeof(TextBox)) 
                {
                    ((TextBox)control).Text = "";
                }
            }
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            DataRow dr = ds.Tables[0].Rows[selectedRow];

            dr["ISBN"] = txtISBN.Text;
            dr["BookTitle"] = txtTitle.Text;
            dr["EditionNumber"] = Convert.ToInt32(txtEdition.Text);
            dr["Copyright"] = txtCopy.Text;
            dr["AuthorID"] = Convert.ToInt32(comboBox1.SelectedValue);

            da.UpdateCommand = builder.GetUpdateCommand();
            da.Update(ds);
        }
    }
}
